﻿// Digital Clock 2.0
// Author: S.Prashant Sabnekar (mistersps@gmail.com)
// Date: Wed June 27, 2007
// Place: Hyderabad, India
// Description: This is a java script file which computes date and time

plugin.onSHowOptionsDlg = ShowOptionsDlg;

var g_time_adjusted = 10;
var gloc = "Vancouver";
var bgcol = "#000000";
var tcol = "#FFD700";
var dcol = "#FFD700";
var title_italic_status = "False";
var title_bold_status = "True";
var clock_italic_status = "False";
var clock_bold_status = "True";
var gday;
var gdate;
var gmonth;
var gyear;
var ghours;
var gmins;
var gsecs;
var gampm;
var adj_day = 0;
var adj_days = 0;
var adj_months = 0;
var adj_years = 0;
var adj_mins = 0;
var adj_hours = 0;
var adj_sec = 0;
var adj_ampm = 0;

function view_onOpen() {
	options.PutValue("loc",gloc);
	location.innerText = options.GetValue("loc");
	SetColor(bgcol,tcol,dcol);
	Initialize();
	Display();
	Counter();
}

function Initialize() {
	var date = new Date();
	gday = date.getDay();
	gmonth = date.getMonth();
	gyear = date.getFullYear();
	gdate = date.getDate();
	ghours = date.getHours();
	gmins = date.getMinutes();
	gsecs = date.getSeconds();	
}

function CalculateAdjustmentVars() {
	g_time_adjusted = 100;
	var d = new Date();
	adj_day = gday - d.getDay();
	adj_days = gdate - d.getDate();
	adj_month = gmonth - d.getMonth();
	adj_year = gyear - d.getFullYear();
	adj_hours = ghours - d.getHours();
	adj_mins = gmins - d.getMinutes();
	adj_sec = gsecs - d.getSeconds();
}

function CalculateTime() {
	if (100 == g_time_adjusted) {
		var d = new Date();
		gday = d.getDay() + adj_day;
		gmonth = d.getMonth() + adj_month;
		gyear = d.getFullYear() + adj_year;		
		ghours = d.getHours() + adj_hours;
		gmins = d.getMinutes() + adj_mins;		
	}
}

function Counter() {
	setTimeout("Timer()",10000);
}

function Timer() {
	gsecs = gsecs + 10;
	CalculateTime();
	Display();
	Counter();
}


function Display() {

	var lday = GetDay(gday);
	var ldate = gdate;
	var lmonth = GetMonth(gmonth);
	var lyear = gyear;
	var lhours = GetHours(ghours);
	var lmins = gmins;
	var lampm = gampm;
	
	var str = lday + " " + ldate + " " + lmonth + " " + lyear +
		"  " + lhours + ":" + lmins + "  " + gampm;
	
	date.innerText = str;
}

function GetDay(day) {
	switch(day) {
		case 0: return "Sun";
		case 1: return "Mon";
		case 2: return "Tue";
		case 3: return "Wed";
		case 4: return "Thu";
		case 5: return "Fri";
		case 6: return "Sat";
		case 7: return "Sun";
		case 8: return "Mon";
		case 9: return "Tue";
		case 10: return "Wed";
		case 11: return "Thu";
		case 12: return "Fri";
		case -1: return "Sat";
		case -2: return "Fri";
		case -3: return "Thu";
		case -4: return "Wed";
		case -5: return "Tue";
		case -6: return "Mon";
	}
}

function GetMonth(mon) {
	switch(mon) {
		case 0: return "Jan";
		case 1: return "Feb";
		case 2: return "Mar";
		case 3: return "Apr";
		case 4: return "May";
		case 5: return "Jun";
		case 6: return "Jul";		
		case 7: return "Aug";
		case 8: return "Sep";
		case 9: return "Oct";
		case 10: return "Nov";
		case 11: return "Dec";		
	}
}

function GetHours(hrs) {
	if (hrs > 12) {
		gampm = "PM";
		return hrs-12;
	} else {
		gampm = "AM";
		return hrs;
	}
}




function SetColor(bc,tc,dc) {
	// Setting default colour
	main_gui_div.background = bc;
	location.color = tc;
	date.color = dc;
}

function SetFontStyle() {
	// setting title font
	location.bold = title_bold_status;
	location.italic = title_italic_status;
	// setting clock font
	date.bold = clock_bold_status;
	date.italic = clock_italic_status;
}

function SetColor2(ele, col_code) {
	switch (col_code) {
		case "#000000": ele.value = "Black"; return;
		case "#00008b": ele.value = "DarkBlue"; return;
		case "#0000ff": ele.value = "Blue" ; return;
		case "#4876ff": ele.value =  "LightBlue"; return;
		case "#1e90ff": ele.value =  "PaleBlue"; return;
		case "#87CEFF": ele.value =  "SkyBlue"; return;
		case "#FF8C00": ele.value =  "Orange"; return;
		case "#FFA500": ele.value =  "LightOrange"; return;
		case "#FFA54F": ele.value =  "Tan"; return;
		case "#595959": ele.value =  "Grey"; return;
		case "#FF0000": ele.value =  "Red"; return;
		case "#32CD32": ele.value =  "Lime"; return;
		case "#66CDAA": ele.value =  "Aqua"; return;
		case "#FF1493": ele.value =  "Pink"; return;
		case "#FFD700": ele.value =  "Gold"; return;
		case "#FFFF00": ele.value =  "Yellow"; return;
		case "#00EE00": ele.value =  "BrightGreen"; return;
		case "#40E0D0": ele.value =  "Turquoise"; return;
		case "#DDA0DD": ele.value =  "Plum"; return;
		case "#9AFF9A": ele.value =  "LightGreen"; return;
		case "#FFE4E1": ele.value =  "Rose"; return;
		case "#FFFFE0": ele.value =  "LightYellow"; return;
		case "#E6E6FA": ele.value =  "Lavender"; return;
		case "#FFFFFF": ele.value =  "White"; return;	
	}
}

function ShowOptionsDlg(wnd) {
	//
	// Creating the options dialog
	//

	var y_offset1 = 20;

	var o2 = 5;
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Day",90,65+o2,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Date",170,65+o2,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Month",260,65+o2,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Year",350,65+o2,60,24);
	// Title
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Set Date and Time",20,10,100,24);
	// Location
	wnd.AddControl(gddWndCtrlClassLabel,0,"locc","Location",20,35,50,24);
	var l = wnd.AddControl(gddWndCtrlClassEdit,0,"loc",gloc,75,35,100,24);
	// Date
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Date",20,65+y_offset1,50,20);
	var d = new Array("Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"); 	
	var day = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"day_list", d, 75,65+y_offset1,80,20);
	var dt = new Array("1", "2", "3", "4", "5", "6", "7", "8" ,"9", "10",
				"11", "12", "13", "14", "15", "16", "17", "18", "19", "20", 
				"21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31");
	var date = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"date_list", dt, 155,65+y_offset1,90,20);
	var m = new Array("January", "February", "March", "April", "May", "June",
			"July", "August", "September", "October", "November", "December");
	var month = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"month_list", m, 245,65+y_offset1,90,20);
	
	var y = new Array("2007", "2008", "2009", "2010", "2011");
	var year = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"year_list", y, 335,65+y_offset1,90,20);
	// Time
	var y_offset = 40;
	var o3 = 15;
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Hours",90,100+o3,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Minutes",175,100+o3,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Seconds",255,100+o3,60,24);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","A.M/P.M",350,100+o3,60,24);
		
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Time",20,90+y_offset,60,24);
	var h = new Array("0","1", "2", "3", "4", "5", "6", "7", "8" ,
			"9", "10","11", "12");
	var hr = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"hour_list", h, 75,90+y_offset,80,20);
	var mi = new Array("0", "1", "2", "3", "4", "5", "6", "7", "8" ,"9", "10",
				"11", "12", "13", "14", "15", "16", "17", "18", "19", "20", 
				"21", "22", "23", "24", "25", "26", "27", "28", "29", "30",
				"31", "32", "33", "34", "35", "36", "37", "38", "39", "40",
				"41", "42", "43", "44", "45", "46", "47", "48", "49", "50",
				"51", "52", "53", "54", "55", "56", "57", "58", "59", "60");
	var min = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"min_list", mi, 155,90+y_offset,90,20);
	var sec = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"sec_list", mi, 245,90+y_offset,90,20);
	var am = new Array("A.M", "P.M");
	var ampm = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"AmPm_list", am, 335,90+y_offset,90,20);
	// Colours
	var col = new Array("Black", "DarkBlue", "Blue", "LightBlue", "PaleBlue",
				"SkyBlue", "Orange", "LightOrange", "Tan", "Grey", "Red", 
				"Lime", "Aqua", "Pink", "Gold", "Yellow", "BrightGreen", 
				"Turquoise", "Plum", "LightGreen", "Rose", "LightYellow",
				"Lavender", "White");
		
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Background Color",20,120+y_offset,100,24);
	var bcol = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"BColour", col, 120,115+y_offset,90,20);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Title Color",20,140+y_offset,100,24);
	var tc = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
					"TColour", col, 120,140+y_offset,90,20);
	wnd.AddControl(gddWndCtrlClassLabel,0,"","Clock Color",20,165+y_offset,100,24);
	var ccol = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
				"CColour", col, 120,165+y_offset,90,20);
	

	// Title Font
	var fo = new Array("Regular", "Bold", "Italic");
	wnd.AddControl(gddWndCtrlClassLabel, 0 , "", "Title Font", 20,195+y_offset, 90,20);
	var tfont = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
						"Title_Font", fo, 120, 195+y_offset, 90,20);
	// Clock Font
	wnd.AddControl(gddWndCtrlClassLabel, 0 , "", "Clock Font", 20,220+y_offset, 90,20);
	var cfont = wnd.AddControl(gddWndCtrlClassList,
					gddWndCtrlTypeListDrop,
						"Clock_Font", fo, 120, 220+y_offset, 90,20);
	//
	// Initializing options dialog
	//
	day.value = "Sat";
	date.value = gdate;
	month.value = gmonth;
	year.value = gyear;
	hr.value = ghours;
	min.value = gmins;
	sec.value = gsecs;
	ampm.value = gampm;
	SetColor2(bcol, bgcol);
	SetColor2(tc, tcol);
	SetColor2(ccol, dcol);
	// Title Font
	if ("True" == title_bold_status) {
		tfont.value = "Bold";
	} else if ("True" == title_italic_status) {
		tfont.value = "Italic";
	} else {
		tfont.value = "Regular";
	}
	// Clock Font
	if ("True" == clock_bold_status) {
		cfont.value = "Bold";
	} else if ("True" == clock_italic_status) {
		cfont.value = "Italic";
	} else {
		cfont.value = "Regular";
	}
	// on options dialog is closed
	wnd.onClose = OptionsDlgClosed;
}
